// **********************************************************************
//
//      PICServerDataBase.cpp
//
// **********************************************************************
// Copyright (C) 1997 PicSearch Team
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//
// General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// For any comments please contact: klemstro@cs.helsinki.fi
//
// ********************************************************************** 


#include<PICServerDataBase.h>

MAKE_PICOBJECTCLASS(PICServerData, PicObject)
MAKE_PICOBJECTCLASS(PICServerDbData, PicObject)
MAKE_PICOBJECTCLASS(PICDbAlgorithm, PicObject)
MAKE_PICOBJECTCLASS(PICUserInfo, PicObject)
MAKE_PICOBJECTCLASS(PICDbRight, PicObject)


PICServerData::PICServerData()
{

}

PICServerData::PICServerData(const PICServerData &other) :
  ipAddress(other.ipAddress), 
  portNbr(other.portNbr),
  name(other.name), 
  httpAddress(other.httpAddress),
  commercial(other.commercial), 
  authLevel(other.authLevel),
  canChangePassword(other.canChangePassword)
{
  if(this != &other){
    databases = other.databases;
    algorithms = other.algorithms;
    users = other.users;
    allDatabases = other.allDatabases;
  }
}

PICServerData::~PICServerData()
{

}


PicObject& PICServerData::operator = (const PicObject& other)
{
  undefined("PICServerData::operator =");
  return *this;
}

PICBOOL PICServerData::operator == (const PicObject& other) const
{
  return (this == &other);
}

PICBOOL PICServerData::operator <  (const PicObject&) const
{
  undefined("PICServerData::operator <");
  return boolFalse;
}

PICBOOL PICServerData::isNull() const
{
  return boolFalse;
}

void PICServerData::setNull()
{
}

BaseString PICServerData::getImage() const
{
  return BaseString();
}

void PICServerData::setImage(const BaseString& image)
{
  undefined("PICServerData::setImage");
}

// **********************************************************************

PICServerDbData::PICServerDbData()
{

}

PICServerDbData::~PICServerDbData()
{

}

PICServerDbData::PICServerDbData(const PICServerDbData &other) :
  name(other.name), id(other.id), userRightsLevel(other.userRightsLevel)
{
  if(this != &other){
    dbAlgIds = other.dbAlgIds;
  }
}


PicObject& PICServerDbData::operator = (const PicObject& other)
{
  undefined("PICServerDbData::operator =");
  return *this;
}

PICBOOL PICServerDbData::operator == (const PicObject& other) const
{
  return (this == &other);
}

PICBOOL PICServerDbData::operator <  (const PicObject&) const
{
  undefined("PICServerDbData::operator <");
  return boolFalse;
}

PICBOOL PICServerDbData::isNull() const
{
  return boolFalse;
}

void PICServerDbData::setNull()
{
}

BaseString PICServerDbData::getImage() const
{
  return BaseString();
}

void PICServerDbData::setImage(const BaseString& image)
{
  undefined("PICServerDbData::setImage");
}

// **********************************************************************

PICDbAlgorithm::PICDbAlgorithm()
{

}

PICDbAlgorithm::~PICDbAlgorithm()
{

}

PICDbAlgorithm::PICDbAlgorithm(const PICDbAlgorithm &other) :
  id(other.id), name(other.name), description(other.description), 
  tk(other.tk)
{

}

PicObject& PICDbAlgorithm::operator = (const PicObject& other)
{
  undefined("PICDbAlgorithm::operator =");
  return *this;
}

PICBOOL PICDbAlgorithm::operator == (const PicObject& other) const
{
  return (this == &other);
}

PICBOOL PICDbAlgorithm::operator <  (const PicObject&) const
{
  undefined("PICDbAlgorithm::operator <");
  return boolFalse;
}

PICBOOL PICDbAlgorithm::isNull() const
{
  return boolFalse;
}

void PICDbAlgorithm::setNull()
{
}

BaseString PICDbAlgorithm::getImage() const
{
  return BaseString();
}

void PICDbAlgorithm::setImage(const BaseString& image)
{
  undefined("PICDbAlgorithm::setImage");
}

// ********************************************************************** 

// ======================================================================
// ======================================================================


PICUserInfo::PICUserInfo()
{

}

PICUserInfo::~PICUserInfo()
{

}

PICUserInfo::PICUserInfo(const PICUserInfo &other) :
  name(other.name), 
  authLevel(other.authLevel),
  canChangePassword(other.canChangePassword)
{
  if(this != &other){
    dbRights = other.dbRights;
  }
}

PicObject& PICUserInfo::operator = (const PicObject& other)
{
  undefined("PICUserInfo::operator =");
  return *this;
}

PICBOOL PICUserInfo::operator == (const PicObject& other) const
{
  return (this == &other);
}

PICBOOL PICUserInfo::operator <  (const PicObject&) const
{
  undefined("PICUserInfo::operator <");
  return boolFalse;
}

PICBOOL PICUserInfo::isNull() const
{
  return boolFalse;
}

void PICUserInfo::setNull()
{
}

BaseString PICUserInfo::getImage() const
{
  return BaseString();
}

void PICUserInfo::setImage(const BaseString& image)
{
  undefined("PICUserInfo::setImage");
}

// ======================================================================
// ======================================================================


PICDbRight::PICDbRight()
{

}

PICDbRight::~PICDbRight()
{

}

PICDbRight::PICDbRight(const PICDbRight &other) :
  id(other.id), authLevel(other.authLevel)
{

}

PicObject& PICDbRight::operator = (const PicObject& other)
{
  undefined("PICDbRight::operator =");
  return *this;
}

PICBOOL PICDbRight::operator == (const PicObject& other) const
{
  return (this == &other);
}

PICBOOL PICDbRight::operator <  (const PicObject&) const
{
  undefined("PICDbRight::operator <");
  return boolFalse;
}

PICBOOL PICDbRight::isNull() const
{
  return boolFalse;
}

void PICDbRight::setNull()
{
}

BaseString PICDbRight::getImage() const
{
  return BaseString();
}

void PICDbRight::setImage(const BaseString& image)
{
  undefined("PICDbRight::setImage");
}


// ======================================================================
// ======================================================================


