// **********************************************************************
//  This file contains the algorithm related routines of PicMain
//  Part of : PicCore
// **********************************************************************
// Copyright (C) 1997 PicSearch Team
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version. 
//
// This program is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
//
// General Public License for more details. 
// You should have received a copy of the GNU General Public License 
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
//
// For any comments please contact: klemstro@cs.helsinki.fi
//
// **********************************************************************

#include <mmain.hxx>
#include <passarr.hxx>
#include <bstrarr.hxx>
#include <ptext.hxx>
#include <picerror.hxx>
#include <searchtype.hxx>
#include <PicSignature.hxx>

#include <PICClient.h>

// **********************************************************************

PICBOOL PicMain::changeSearchType(BaseString searchTypeName,
	BaseStringArray &algNames)
{
  PicErrorContext errcxt;

  DEBUG_CORE("Setting search type to " & searchTypeName & "\n");
  PicSearchType* sType = globData.getSearchType(searchTypeName);

  if(sType){
    PICUSHORT foundAlgs = sType->algs.size();
    if(DEBUG_CORE_ON){
      PICUSHORT pos = sType->algs.next(0);
      while(pos)
      {
        DEBUG_CORE("Search type contains " & sType->algs[pos] & "\n");
        pos = sType->algs.next(pos);
      }
    }
    
//    BaseStringArray availableAlgs, algsUsed;
    // NETP: call to PICClient::getAvailableAlgs(availableAlgs);
    //       (assuming that PICClient knows "current database")
    //       If there is no connection getAvailableAlgs 
    //       should return boolFalse as return value

//      if(PICClient::getAvailableAlgs(availableAlgs){
//        PICPOSITION pos = availableAlgs.next(0);
//        while(pos)
//        {
//          if(sType->algs.contains(availableAlgs[pos]) ||
//             globData.getSearchAlg(availableAlgs[pos]) == NULLPTR)
//          {
//            algsUsed.add(availableAlgs[pos]);
//          }
//          pos = availableAlgs.next(pos);
//        }
//      }else{
//      algsUsed = sType->algs;
//      }

    globData.currentSearchType = searchTypeName;
	algNames = sType->algs;

    PicStringText mesg;
    mesg("Search type changed to \"@*\", @* algorithm@* available\n")
        << searchTypeName << foundAlgs << (foundAlgs==1 ? "" : "s")  ENDFMT;
    INFO_PRINT(mesg);
    return boolTrue;
  }
  INFO_PRINT("Change of search type failed:\n");
  FLUSH_ERRORS()
  
  return boolFalse;
}

// **********************************************************************

BaseString PicMain::getSignatureImage(BaseString algName,
                                      PICULONG listIndex)
{
  BaseString retVal("- Not available -");
  PicPicture *pic = getExamplePic(listIndex);

  DEBUG_CORE("JL: getSignatureImage DISABLED!\n");
  
  /*
  if(pic){
    PicIterator iter;
    PicSignature *sign = NULLPTR;
    PicSearchAlgorithm* alg = globData.getSearchAlg(algName);

    if(alg){
      PicSignature *refSign = alg->createEmpty();
      if(refSign){
        ITERATE(pic->signatures, iter)
        {
          sign = &AS(PicSignature, pic->signatures.at(iter));
          if(sign->virtId() == refSign->virtId())
            break;
          else
            sign = NULLPTR;
        }
        if(sign){
          retVal = sign->getImage();
        }
        delete refSign;
      }
    }
  }
*/ 
   
   return retVal;
}

