// --------------------------------------------------------------------------
//  PicList class definition
//
//  This is a very simple list class to keep anything in it
//  which can be casted into (void *). 
//
//  A more standard STL list would have been used, but including
//  it into the PICSearch build in the compile environment of 
//  University of Helsinki (dept. of Computer Science) just didn't
//  work out. With any recent (decent) compiler tools there should
//  be no problem to use STL.
//
//  Part of : PicLib
// --------------------------------------------------------------------------
// Copyright (C) 1999 PicSearch Team
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version. 
//
// This program is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
//
// General Public License for more details. 
// You should have received a copy of the GNU General Public License 
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
//
// For any comments please contact: klemstro@cs.helsinki.fi
//
// --------------------------------------------------------------------------

#ifndef PICLIST_HXX
#define PICLIST_HXX

class PicList
{
	struct ListStruct
	{
		void *list_node;
		struct ListStruct *list_next;
	};

	public:
		PicList();
		~PicList();
	
		void listClean(void);
		void listRewind(void);
		void *listCurrent(void);
		void *listNext(void);
		int listAdd(void *node);
		int listRemove(void *node);
	private:
		struct ListStruct *list_head;
		struct ListStruct *list_current;
};

#endif
