// --------------------------------------------------------------------------
//  PIC PARAMETRIZATION DEFAULTS
//  Part of : PicLib
// --------------------------------------------------------------------------
// Copyright (C) 1997 PicSearch Team
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version. 
//
// This program is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
//
// General Public License for more details. 
// You should have received a copy of the GNU General Public License 
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
//
// For any comments please contact: klemstro@cs.helsinki.fi
//
// --------------------------------------------------------------------------

#ifndef PICDEFAULT_HXX
#define PICDEFAULT_HXX

#include <pchar.hxx>
#include <bdate.hxx>
#include <btime.hxx>

// --------------------------------------------------------------------------
//      DEFAULT PARAMETER VALUES FOR ARITHMETIC CLASSES
//:var ----------------------------------------------------------------------

#define PIC_LOGIC_TRUE    "true"
#define PIC_LOGIC_FALSE   "false"
#define PIC_LOGIC_UNKNOWN "unknown"

const char  defaultDecimalPoint     = '.';

/*
These are the default (hard-coded) parameter values for arithmetic classes:
    PicLogic
    PicReal
*/

// --------------------------------------------------------------------------
//      DEFAULT PARAMETER VALUES FOR TIME
//:var ----------------------------------------------------------------------

const PicTimeResolution defaultTimeResolution = BaseTime::hoursToMinutes;
const PicTimeStyle      defaultTimeStyle      = BaseTime::hours24;
const char              defaultTimeDelimiter  = ':';
const char              defaultTimeLeader     = '\0';

/*
These are the default (hard-coded) parameter values for PicTime/BaseTime.
*/

// --------------------------------------------------------------------------
//      DEFAULT PARAMETER VALUES FOR DATE
//:var ----------------------------------------------------------------------

const PicDateResolution defaultDateResolution = BaseDate::yearsToDays;
const PicDateStyle      defaultDateStyle      = BaseDate::dayFirst;
const char              defaultDateDelimiter  = '-';
const char              defaultDateLeader     = '\0';
const PicYearMWStyle    defaultYearMWStyle    = BaseDate::year4;

/*
These are the default (hard-coded) parameter values for PicDate/BaseDate.
*/

#define PIC_SHORTMONTH1    "Jan"
#define PIC_SHORTMONTH2    "Feb"
#define PIC_SHORTMONTH3    "Mar"
#define PIC_SHORTMONTH4    "Apr"
#define PIC_SHORTMONTH5    "May"
#define PIC_SHORTMONTH6    "Jun"
#define PIC_SHORTMONTH7    "Jul"
#define PIC_SHORTMONTH8    "Aug"
#define PIC_SHORTMONTH9    "Sep"
#define PIC_SHORTMONTH10   "Oct"
#define PIC_SHORTMONTH11   "Nov"
#define PIC_SHORTMONTH12   "Dec"

#define PIC_LONGMONTH1     "January"
#define PIC_LONGMONTH2     "February"
#define PIC_LONGMONTH3     "March"
#define PIC_LONGMONTH4     "April"
#define PIC_LONGMONTH5     "May"
#define PIC_LONGMONTH6     "June"
#define PIC_LONGMONTH7     "July"
#define PIC_LONGMONTH8     "August"
#define PIC_LONGMONTH9     "September"
#define PIC_LONGMONTH10    "October"
#define PIC_LONGMONTH11    "November"
#define PIC_LONGMONTH12    "December"

#define PIC_WEEKDAY1       "Monday"
#define PIC_WEEKDAY2       "Tuesday"
#define PIC_WEEKDAY3       "Wednesday"
#define PIC_WEEKDAY4       "Thursday"
#define PIC_WEEKDAY5       "Friday"
#define PIC_WEEKDAY6       "Saturday"
#define PIC_WEEKDAY7       "Sunday"

#define PIC_SHORT_WEEKDAY1 "Mon"
#define PIC_SHORT_WEEKDAY2 "Tue"
#define PIC_SHORT_WEEKDAY3 "Wed"
#define PIC_SHORT_WEEKDAY4 "Thu"
#define PIC_SHORT_WEEKDAY5 "Fri"
#define PIC_SHORT_WEEKDAY6 "Sat"
#define PIC_SHORT_WEEKDAY7 "Sun"

#endif
