// --------------------------------------------------------------------------
//  OBJECT PTR ARRAY
//  Part of : PicLib
// --------------------------------------------------------------------------
// Copyright (C) 1997 PicSearch Team
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version. 
//
// This program is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
//
// General Public License for more details. 
// You should have received a copy of the GNU General Public License 
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
//
// For any comments please contact: klemstro@cs.helsinki.fi
//
// --------------------------------------------------------------------------

// Edit these defines:
// -------------------
#ifndef PICOBJECT_PTR_ARRAY_HXX
#define PICOBJECT_PTR_ARRAY_HXX

#ifdef ITEM_CLASS
#undef ITEM_CLASS
#endif

#ifdef ITEM_CLASS_ARRAY
#undef ITEM_CLASS_ARRAY
#endif

#ifdef ITEM_CLASS_ARRAY_NAME
#undef ITEM_CLASS_ARRAY_NAME
#endif

// Edit these defines:
// -------------------
#define ITEM_CLASS             PPicObject
#define ITEM_CLASS_ARRAY       PicObjectPtrArray
#define ITEM_CLASS_ARRAY_NAME  "PicObjectPtrArray"

// Edit this include:
// ------------------
#include <pobject.hxx>
typedef PicObject* PPicObject;

#include <genarr1.hgn>

    PicObject* replace (PICPOSITION, PicObject* pobj);
    void       swap    (PICPOSITION, PICPOSITION);

    PICBOOL     putAt (PICPOSITION, PicObject*);
    PICPOSITION addAt (PICPOSITION, PicObject*);
    PICPOSITION add   (PicObject*);

    PICBOOL operator == (const PicObjectPtrArray&) const;

#include <genarr2.hgn> 

// --------------------------------------------------------------------------
//  ADDITIONAL INLINE DEFINITIONS

inline PICBOOL PicObjectPtrArray::putAt (PICPOSITION pos, PicObject* item)
       { return put(pos) ? (at(pos) = item, boolTrue) : boolFalse; }

inline PICPOSITION PicObjectPtrArray::addAt (PICPOSITION pos, PicObject* item)
       { return (pos = insert(pos)) ? (at(pos) = item, pos) : 0; }

inline PICPOSITION PicObjectPtrArray::add (PicObject* item)
       { PICPOSITION pos; return (pos = insert()) ? (at(pos) = item, pos) : 0; }

inline PicObject* PicObjectPtrArray::replace (PICPOSITION pos, PicObject* pobj)
       { PicObject* old = THIS[pos]; THIS[pos] = pobj; return old; }

inline void PicObjectPtrArray::swap (PICPOSITION i1, PICPOSITION i2)
       { PicObject* pobj = THIS[i1]; THIS[i1] = THIS[i2]; THIS[i2] = pobj; }

#endif
