// **********************************************************************
//  PicLibAlgorithm class definition for library use
//  Part of : PicAlg
// **********************************************************************
// Copyright (C) 1999 PicSearch Team
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version. 
//
// This program is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
//
// General Public License for more details. 
// You should have received a copy of the GNU General Public License 
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
//
// For any comments please contact: klemstro@cs.helsinki.fi
//
// **********************************************************************

#ifndef PICLIBALGORITHM_HXX
#define PICLIBALGORITHM_HXX

#include <PicAlgDefs.hxx>
#include <PicSignature.hxx>
#include <PicPicture.hxx>

class PicLibAlgorithm
{
 public:
	PicLibAlgorithm();

	PICBOOL setParams(PicIxCollect &params);
	PICUSHORT compare(PicSignature &firstSig, PicSignature &secSig);
	PicSignature *computeSignature(PicPicture &pic);
	
	char *algName(void) {
		return(name);
	}
	char *algInfo(void) {
		return(info);
	}
 private:
 	char *name;
	char *info;
};

PicLibAlgorithm tmp;

extern "C"
{
	PICBOOL setParams(PicIxCollect &params) {
		return(tmp.setParams(params));
	}
	PICUSHORT compare(PicSignature &firstSig, PicSignature &secSig) {
		return(tmp.compare(firstSig, secSig));
	}
	PicSignature *computeSignature(PicPicture &pic) {
		return(tmp.computeSignature(pic));
	}
	char *algName(void) {
		return(tmp.algName());
	}
	char *algInfo(void) {
		return(tmp.algInfo());
	}
}

// **********************************************************************

#endif

